//
//  QGFilterController.h
//  YTest
//
//  Created by Matthew McCowan on 7/18/07.
//  Copyright 2007 Quickgigs, Inc. All rights reserved.
//

#import "QGFoundation.h"
#import "QGFilterView.h"
#import "QGFilterBrowser.h"
#import "QGInputValue.h"
#import "QGFilterInputController.h"
#import "QGDynamicController.h"


@interface QGFilterController : QGDynamicController
{
	// Instance
	NSString       *name;
	NSMutableArray *inputs;
	float           currentX;
	CIFilter       *filter;

	// Outlets
	IBOutlet NSTextField *titleField;
}

// Initialization
- (id) initUsingFilterIndex:(unsigned)filterIndex forOwner:(id)initOwner;

// Properties
- (CIFilter *) filter;

// Actions
- (IBAction) removeSelf:(id)sender;

// Values
- (BOOL) hasValue;
- (void) addValuesToArray:(NSMutableArray *)array markedAsIndex:(unsigned)index;
- (void) addValue:(id)value atInputKey:(NSString *)inputKey;

@end
