//
//  QGImage.h
//  Quickgigs Immutation
//
//  Created by Matthew McCowan on 4/15/07.
//  Copyright 2007 Quickgigs, Inc.. All rights reserved.
//

#import "QGFoundation.h"
#import "QGImageCommons.h"
#import "QGChainController.h"

@interface QGImage : QGObject 
{
	CIImage  *image;
	CGRect    imageBounds;
	CIImage  *filteredImage;
	CGRect    filteredBounds;

	NSURL     *url;
	NSString  *path;
	NSString  *filename;

	NSString  *baseFilename;
	NSString  *filteredPath;
	BOOL       filteredImageWasSaved;
}

// Initialization
- (id) initFromData:(NSData *)data;
- (id) initFromPath:(NSString *)path;
- (id) initFromCIImage:(CIImage *)initImage;
- (void) initCommon;


// Properties
- (BOOL) hasImage;
- (CIImage *) image;
- (NSString *) path;
- (NSString *) filteredPath;
- (NSString *) filename;
- (NSString *) baseFilename;
- (CGRect) bounds;
- (BOOL) filteredImageHasBeenSaved;
- (CFStringRef) filteredImageUTI;


// Setters
- (void) setImage:(CIImage *)newImage;
- (void) setPath:(NSString *)newPath;
- (void) setFilteredPath:(NSString *)newFilteredPath;
- (void) clearFilteredImage:(NSNotification *)note;
- (void) setFilename:(NSString *)newFilename;
- (void) setFilteredDir:(NSString *)newDir;
- (void) setFilteredImageUsingChainController:(QGChainController *)chainController;

// Drawing
- (void) drawImageInContext:(CIContext *)context insideBounds:(CGRect)bounds;
- (void) drawImageInContext:(CIContext *)context insideBounds:(CGRect)bounds usingChainController:(QGChainController *)chainController;

// File
- (BOOL) writeFilteredImage;

@end
